<!--
~ Copyright (c) 2005-2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
~
~ WSO2 Inc. licenses this file to you under the Apache License,
~ Version 2.0 (the "License"); you may not use this file except
~ in compliance with the License.
~ You may obtain a copy of the License at
~
~ http://www.apache.org/licenses/LICENSE-2.0
~
~ Unless required by applicable law or agreed to in writing,
~ software distributed under the License is distributed on an
~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
~ KIND, either express or implied. See the License for the
~ specific language governing permissions and limitations
~ under the License.
-->

<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.apache.commons.logging.Log" %>
<%@ page import="org.apache.commons.logging.LogFactory" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.AdminConsoleClient" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.beans.DatabaseInfo" %>
<%@ page import="org.wso2.carbon.adminconsole.ui.beans.DatabaseUserInfo" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>

<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%
    Log log = LogFactory.getLog(this.getClass());

    String instanceName = request.getParameter("instanceName");
    String dbName = request.getParameter("dbName");
    String defaultUsername = request.getParameter("defaultUsername");
    String defaultUserPassword = request.getParameter("defaultUserPassword");
    String flag = request.getParameter("flag");

    AdminConsoleClient client;
    String msg;

    String backendServerUrl = CarbonUIUtil.getServerURL(
            getServletConfig().getServletContext(), session);
    ConfigurationContext configContext = (ConfigurationContext) config.
            getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    client = new AdminConsoleClient(cookie, backendServerUrl, configContext);
   if (!"drop".equals(flag)) {
    try {
        DatabaseInfo dbInfo = new DatabaseInfo();
        dbInfo.setInstanceName(instanceName);
        dbInfo.setDbName(dbName);

        DatabaseUserInfo userInfo = new DatabaseUserInfo();
        userInfo.setInstanceName(instanceName);
        userInfo.setDbName(dbName);
        userInfo.setUsername(defaultUsername);
        userInfo.setPassword(defaultUserPassword);

        msg = client.createDatabase(dbInfo);
        if (msg.contentEquals("Database has been successfully created")) {
            client.createDbUser(userInfo);
%>
        <script type="text/javascript">
            CARBON.showConfirmationDialog("Database has been successfully created");
        </script>
<%
        } else if (msg.contentEquals("A database with the same name already exists")){
%>
        <script type="text/javascript">
            CARBON.showErrorDialog("A database with the same name already exists");
        </script>
<%
        } else {
%>
        <script type="text/javascript">
            CARBON.showErrorDialog("Failed to create the database");
        </script>
<%
         }
        }
        catch (Exception e) {
            log.error(e);
        }
    } else {
            client.dropDatabase(instanceName, dbName);
        }

%>
<script type="text/javascript">
    document.location.href = "databases.jsp?";
</script>
